﻿//
// App.xaml.h
// Declaration of the App class.
//

#pragma once

#include "App.g.h"

namespace MobileServicesApp
{
	/// <summary>
	/// Provides application-specific behavior to supplement the default Application class.
	/// </summary>
	ref class App sealed
	{
	public:
		App();
		virtual void OnLaunched(Windows::ApplicationModel::Activation::LaunchActivatedEventArgs^ args) override;
		static property Microsoft::WindowsAzure::MobileServices::MobileServiceClient^ MobileClient
		{
			Microsoft::WindowsAzure::MobileServices::MobileServiceClient^ get()
			{
				return client_;
			}			
		}

		static property Windows::Networking::PushNotifications::PushNotificationChannel^ CurrentChannel
		{
			Windows::Networking::PushNotifications::PushNotificationChannel^ get()
			{
				return channel_;
			}
			void set(Windows::Networking::PushNotifications::PushNotificationChannel^ notificationChannel)
			{
				channel_ = notificationChannel;
			}
		}
		
	private:
		void OnSuspending(Platform::Object^ sender, Windows::ApplicationModel::SuspendingEventArgs^ e);
		void OnPushNotificationReceived(Windows::Networking::PushNotifications::PushNotificationChannel^ channel, Windows::Networking::PushNotifications::PushNotificationReceivedEventArgs^ e);
	private:
		static Microsoft::WindowsAzure::MobileServices::MobileServiceClient^ client_;
		static Windows::Networking::PushNotifications::PushNotificationChannel^ channel_;
		
		void AcquirePushChannel();		
	};
}
