// RefTemplate.cpp : Defines the entry point for the console application.
//

#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

#include <collection.h>
using namespace Platform;

int ComputeSumPassArray(const Array<int>^ list)
{
    int sum = 0;
    const auto size = list->Length;
    for(unsigned int x = 0; x < size; ++x)
    {
        sum += list[x];
    }
    return sum;
}

void CreateRecvArray(Array<int>^* list)
{
    auto temp = ref new Array<int>(100);
    for(unsigned int i = 0; i < temp->Length; i++)
    {
        temp[i] = i;
    }

    *list = temp;
}

Array<int>^ CreateRecvArray2()
{
    auto temp = ref new Array<int>(10);    
    for(unsigned int i = 0; i < temp->Length; i++)
    {
        temp[i] = i;
    }

    return temp;

}

void CreateList(WriteOnlyArray<int>^ list)
{
    // You can write to the elements directly.
    for(unsigned int i = 0; i < list->Length; i++)
    {
        list[i] = i;
    } 
}


void ArrayConversions(const Array<int>^ arr)
{
    // Construct an Array from another Array.
    Platform::Array<int>^ newArr = ref new Platform::Array<int>(arr);

    // Construct a Vector from an Array
    auto v = ref new Platform::Collections::Vector<int>(arr); 

    // Construct a std::vector. Two options.
    vector<int> v1(begin(arr), end(arr));

    vector<int> v2(arr->begin(), arr->end());

    // Initialize a vector one element at a time.
    // using a range for loop. Not as efficient as using begin/end.
    vector<int> v3;
    for(int i : arr)
    {
        v3.push_back(i);
    }   
}


int main(Platform::Array<Platform::String^>^ args)
{
    std::vector<int> vec(100);
    int i = -1;
    std::generate(vec.begin(), vec.end(), [&i] () { return ++i; } );

    auto arr = ref new Platform::Array<int>(100);

    for(unsigned int i = 0; i < vec.size(); ++i)
    {
        arr->set(i, vec[i]);
    }

    int result = ComputeSumPassArray(arr);
    wcout << "The result is "<< result << endl;

    Array<int>^ recvArray;
    CreateRecvArray(&recvArray);
    result = ComputeSumPassArray(recvArray);
    wcout << "The result is "<< result << endl;

    auto list = CreateRecvArray2();
    result = ComputeSumPassArray(recvArray);
    wcout << "The result is "<< result << endl;

    auto writeArray = ref new Platform::Array<int>(100);
    CreateList(writeArray);
    result = ComputeSumPassArray(recvArray);
    wcout << "The result is "<< result << endl;

    return 0;
}

