﻿// Class1.cpp
#include "pch.h"
#include "Class1.h"
#include "stdReadFile.h"

using namespace CxxBuildWordList;
using namespace Platform;
using namespace Platform::Collections;
using namespace Windows::Foundation;
using namespace Windows::Foundation::Collections;
using namespace Windows::Storage;
using namespace Windows::Storage::Pickers;

WordList::WordList()
{
}

IVector<String^>^ WordList::BuildWordList(Platform::String^ fileName)
{	
    Vector<String^>^ vec = ref new Vector<String^>();
    auto appLocation = Windows::ApplicationModel::Package::Current->InstalledLocation;
    auto itemPath = appLocation->Path;
    itemPath += "\\Assets\\Odyssey.txt";	

    std::wstring s = itemPath->Data();
    std::string str;
    str.assign(s.begin(), s.end());
    std::vector<std::string> list = BuildList(str);

    auto it = list.begin();
    auto end = list.end();

    for (; it != end; ++it)
    {
        std::string str(*it);
        std::wstring s;
        s.assign(str.begin(), str.end());
        vec->Append(ref new String(s.c_str()));
    }
    return vec; 

}

//Word List building function using the system thread pool API
IAsyncAction^ WordList::BuildWordListTp(Platform::String^ fileName)
{
    auto workItemDelegate = [this](IAsyncAction^ workitem)
    {
        auto status = workitem->Status;
        if (AsyncStatus::Canceled == status)
        {
            // handle cancellation here
        }

        //do the actual work here
        vec = ref new Vector<String^>();
        auto appLocation = Windows::ApplicationModel::Package::Current->InstalledLocation;
        auto itemPath = appLocation->Path;
        itemPath += "\\Assets\\Odyssey.txt";	

        std::wstring s = itemPath->Data();
        std::string str;
        str.assign(s.begin(), s.end());
        std::vector<std::string> list = BuildList(str);

        auto it = list.begin();
        auto end = list.end();

        for (; it != end; ++it)
        {
            std::string str(*it);
            std::wstring s;
            s.assign(str.begin(), str.end());
            vec->Append(ref new String(s.c_str()));
        }
    };

    auto workItemHandler = ref new Windows::System::Threading::WorkItemHandler(workItemDelegate);    

    IAsyncAction^ action = Windows::System::Threading::ThreadPool::RunAsync(workItemHandler, Windows::System::Threading::WorkItemPriority::Normal);
    return action;
}

