// RefTemplate.cpp : Defines the entry point for the console application.
//

#include <string>

#include "RefTemplate.h"

using namespace Platform;
using namespace Platform::Details;

using namespace std;

int main(Platform::Array<Platform::String^>^)
{
    // Create person attributes using standard C++ strings
    const std::wstring firstName = L"John";
    const std::wstring lastName = L"Doe";
    const std::wstring email = L"John.Doe@somewhere.com";

    // Create the Cpp CX Person object and set attributes
    // These attributes delegate down to the embedded ISO Standard Person object
    auto p = ref new Person();
    p->FirstName = ref new String(firstName.c_str());
    p->LastName = ref new String(lastName.c_str());
    p->EmailAddress = ref new String(email.c_str());

    // Output the data to the command line
    Console::WriteLine(p->FirstName);
    Console::WriteLine(p->LastName);
    Console::WriteLine(p->FullName);
    Console::WriteLine(p->EmailAddress);

    return 0;
}

