#pragma once

#include "Person.h"

ref class Person sealed
{
public:
    Person() {}
    virtual ~Person() {}

    property Platform::String^ FirstName
    {
        Platform::String^ get() 
        {
            return ref new Platform::String(_person.getFirstName().c_str());
        }

        void set(Platform::String^ value)
        {
            if (value->IsEmpty())
            {
                throw ref new Platform::InvalidArgumentException();
            }
            _person.setFirstName(value->Data());
        }
    }

    property Platform::String^ LastName
    {
        Platform::String^ get() 
        {
            return ref new Platform::String(_person.getLastName().c_str());
        }

        void set(Platform::String^ value)
        {
            if (value->IsEmpty())
            {
                throw ref new Platform::InvalidArgumentException();
            }
            _person.setLastName(value->Data());
        }
    }

    property Platform::String^ EmailAddress
    {
        Platform::String^ get() 
        {
            return ref new Platform::String(_person.getEmailAddress().c_str());
        }

        void set(Platform::String^ value)
        {
            if (value->IsEmpty())
            {
                throw ref new Platform::InvalidArgumentException();
            }
            _person.setEmailID(value->Data());
        }
    }

    property Platform::String^ FullName
    {
        Platform::String^ get()
        {
            return ref new Platform::String(_person.getName().c_str());
        }
    }

private:
    x::Person _person;
};
