#include <collection.h>

using namespace Platform;

namespace CxxDelegates
{	
    ref class Person;
    public delegate Platform::String^ GetNameDelegate(Person^ p);

    public ref class Person sealed
    {
        public:			
            Person() {}
            Person(String^ firstName, String^ lastName, String^ email) 
            {
                fName = firstName;
                lName = lastName;
                emailAddress = email;
            }

            virtual ~Person() {}

            property String^ FirstName
            {
                String^ get() 
                {
                    return fName;
                }

                void set(String^ firstName)
                {
                    if (firstName->IsEmpty())
                    {
                        throw ref new Platform::InvalidArgumentException();
                    }
                    fName = firstName;
                }
            }

            property String^ LastName
            {
                String^ get() 
                {
                    return lName;
                }

                void set(String^ lastName)
                {
                    if (lastName->IsEmpty())
                    {
                        throw ref new Platform::InvalidArgumentException();
                    }
                    lName = lastName;
                }
            }

            property String^ EmailAddress
            {
                String^ get() 
                {
                    return emailAddress;
                }

                void set(String^ emailID)
                {
                    if (emailID->IsEmpty())
                    {
                        throw ref new Platform::InvalidArgumentException();
                    }
                    emailAddress = emailID;
                }
            }


            String^ GetFullName(GetNameDelegate^ func )
            {
                return func(this);
            }

        private:
            String^ fName;
            String^ lName;
            String^ emailAddress;
    };	
}