// RefTemplate.cpp : Defines the entry point for the console application.
//

#include <iostream>
using namespace std;

using namespace Platform;
using namespace Platform::Metadata;

namespace CxxEnums
{
    private enum class Colors : short
    {
        Red,
        Yellow,
        Green,
        Black
    };

    public enum class EmpCategory : int
    {
        FTE = 1,
        Vendor,
        Partner,
        Invalid = -1
    };

    [Flags]
    public enum class Bits :uint32
    {
        Field0 = 0x0,
        Field2 = 0x2,
        Field4 = 0x4,
        Field8 = 0x8
    };
}

int main(Platform::Array<Platform::String^>^ args)
{
    using namespace CxxEnums;
    Colors myColor = Colors::Black;
    String^ output = "The color is ";
    output += myColor.ToString();
    wcout << output->Data() << endl; 

    //use C++ casting
    myColor = Colors::Green;
    int x = static_cast<int>(myColor);
    wcout<< x <<endl;

    EmpCategory emp = EmpCategory::Invalid;

    if (emp == EmpCategory::Invalid)
    {
        wcout << "Invalid employee category"<<endl;
    }

    emp = EmpCategory::FTE;
    output = "The Employee category is ";
    output += emp.ToString();
    wcout << output->Data() << endl;

    Bits bitfield = Bits::Field0 | Bits::Field2 | Bits::Field4;

    if ((bitfield & Bits::Field4) == Bits::Field4)
    {
        wcout <<"Bit fields match"<<endl;
    }

    return 0;
}

