// RefTemplate.cpp : Defines the entry point for the console application.
//

#include <iostream>
#include <winerror.h> 
using namespace std;

using namespace Platform;

//create a custom exception type
COMException^ CreateCustomException(unsigned short errorCode)
{
    // we will throw if errorCode == 0 just for illustration
    if (errorCode == 0)
    {
        throw ref new InvalidArgumentException();
    }

    HRESULT customhr = MAKE_HRESULT(SEVERITY_ERROR, FACILITY_ITF, errorCode);

    return ref new COMException(customhr);
}


int main(Platform::Array<Platform::String^>^ args)
{
    try
    {
        auto exception = CreateCustomException(static_cast<unsigned short>(-1));
    }
    catch (InvalidArgumentException^ ex)
    {
        //log exception data
        wcout<< ex->HResult.ToString()->Data() <<endl;
        wcout<< ex->Message->Data() <<endl;
    }

    return 0;
}

