// RefTemplate.cpp : Defines the entry point for the console application.
//

#include <iostream>
using namespace std;

using namespace Platform;
using namespace Platform::Details;

ref class B
{
public:
    virtual void f() { Console::WriteLine("B::f"); }
    virtual void g() { Console::WriteLine("B::g"); }
};
interface class I
{
    void f();
    void g();
};

ref class C : B, I
{
public:

    // f overrides B::f and implements I::f
    virtual void f() override
    {
        Console::WriteLine("C::f");
    }
    // g overrides B::g AND implements I::g
    virtual void g() override
    {
        Console::WriteLine("C::g");
    }
};

[Platform::MTAThread]
int main()
{
    B^ b = ref new B();
    C^ c = ref new C();
    I^ i = c;

    b->f(); // calls B::f
    c->f(); // calls C::f
    i->f(); // calls C::f since C::f implements I::f
    B^ bc = c;  // b pointing to instance of C
    bc->f(); // calls C::f since C::f is unrelated
    // behavior with the override specifier
    b->g();  // calls B::g
    c->g();  // calls C::g
    i->g();  // calls C::g since C::g implements I::g
    bc->g(); // calls C::g since C::g overrides B::g
}
