// RefTemplate.cpp : Defines the entry point for the console application.
//

#include <iostream>
using namespace std;

using namespace Platform;

interface class IInterface
{
    void PrintFunc();
    int PrintNumber();
};

ref class R : IInterface
{
    public:
        virtual int PrintNumber() { return 42 ; }
    
    private:
    // The virtual keyword is required to implement the interface.
    virtual void PrintFunc() sealed = IInterface::PrintFunc
    {
        wcout << __FUNCTION__ <<endl;
    }

};

[Platform::MTAThread]
int main()
{
    R^ r = ref new R();
    IInterface^ ir = r;
    ir->PrintFunc();  // PrintFunc may be called through the interface.
    //r->PrintFunc();  // Error: PrintFunc is private.
    wcout << r->PrintNumber() <<endl;     // OK   
}

