﻿// Class1.cpp
#include "pch.h"
#include "Class1.h"
#include <collection.h>
#include <ppltasks.h>

using namespace CxxReadFileComponent;
using namespace Platform;
using namespace Platform::Collections;
using namespace Windows::Foundation;
using namespace Windows::Foundation::Collections;
using namespace Windows::Storage;
using namespace Windows::Storage::Streams;
using namespace concurrency;

ReadFile::ReadFile()
{
}

IAsyncAction^ ReadFile::ReadTxtFileAsync(String^ fileName)
{
    return create_async([this, fileName]{
        StorageFolder^ item = KnownFolders::DocumentsLibrary;
        task<StorageFile^> getFileTask(item->GetFileAsync(fileName));
        getFileTask.then([](StorageFile^ storageFile){
            task<IRandomAccessStream^> streamTask(storageFile->OpenAsync(FileAccessMode::Read));
            streamTask.then([](IRandomAccessStream^ istream){
                auto Reader = ref new DataReader(istream);
                task<UINT> bytesReadTask(Reader->LoadAsync(istream->Size));
                try
                {
                    UINT bytesRead = bytesReadTask.get();
                }
                catch(Exception^ ex)
                {
                    String^ result = ex->Message;
                }
            });	
        });
    });
}

//we will return a dummy progress on this operation for illustration purposes only
IAsyncActionWithProgress<double>^ ReadFile::ReadTxtFileWithProgressAsync(Platform::String^ fileName)
{
    return create_async([this, fileName](progress_reporter<double> reporter)
    {
        StorageFolder^ item = KnownFolders::DocumentsLibrary;
        task<StorageFile^> getFileTask(item->GetFileAsync(fileName));
        reporter.report(10.0);
        getFileTask.then([reporter](StorageFile^ storageFile)
        {
            task<IRandomAccessStream^> streamTask(storageFile->OpenAsync(FileAccessMode::Read));
            reporter.report(25.0);
            streamTask.then([reporter](IRandomAccessStream^ istream)
            {
                reporter.report(40.0);
                auto Reader = ref new DataReader(istream);
                task<UINT> bytesReadTask(Reader->LoadAsync(istream->Size));
                reporter.report(60.0);
                try
                {
                    UINT bytesRead = bytesReadTask.get();
                    reporter.report(100.0);				
                }
                catch(Exception^ ex)
                {
                    String^ result = ex->Message;
                }
            });	
        });
        reporter.report(100.0);
    });
}

IAsyncOperation<int>^ ReadFile::GetByteCountAsync(Platform::String^ fileName)
{
    return create_async([this, fileName]() -> int 
    {
        StorageFolder^ item = KnownFolders::DocumentsLibrary;
        task<StorageFile^> getFileTask(item->GetFileAsync(fileName));
        getFileTask.then([this](StorageFile^ storageFile)
        {
            task<IRandomAccessStream^> streamTask(storageFile->OpenAsync(FileAccessMode::Read));
            streamTask.then([this](IRandomAccessStream^ istream)
            {
                auto Reader = ref new DataReader(istream);
                task<UINT> bytesReadTask(Reader->LoadAsync(istream->Size));
                try
                {
                    m_bytesRead = bytesReadTask.get();						
                }
                catch(Exception^ ex)
                {
                    String^ result = ex->Message;
                }
            });	
        });
        return m_bytesRead;
    });
}

IAsyncOperationWithProgress<int, double>^ ReadFile::GetByteCountWithProgressAsync(Platform::String^ fileName)
{
    return create_async([this, fileName](progress_reporter<double> reporter) -> int 
    {
        StorageFolder^ item = KnownFolders::DocumentsLibrary;
        task<StorageFile^> getFileTask(item->GetFileAsync(fileName));
        reporter.report(10.0);
        getFileTask.then([this, reporter](StorageFile^ storageFile)
        {
            reporter.report(25.0);
            task<IRandomAccessStream^> streamTask(storageFile->OpenAsync(FileAccessMode::Read));
            streamTask.then([this, reporter](IRandomAccessStream^ istream)
            {
                reporter.report(40.0);
                auto Reader = ref new DataReader(istream);
                task<UINT> bytesReadTask(Reader->LoadAsync(istream->Size));
                reporter.report(60.0);
                try
                {
                    m_bytesRead = bytesReadTask.get();			
                    reporter.report(100.0);
                }
                catch(Exception^ ex)
                {
                    String^ result = ex->Message;
                }
            });	
        });
        reporter.report(100.0);
        return m_bytesRead;
    });
}