﻿#pragma once

namespace CxxReadFileComponent
{
    public ref class ReadFile sealed
    {
    public:
        ReadFile();

        //reads the contents of the file but neither returns a value or the progress
        Windows::Foundation::IAsyncAction^ ReadTxtFileAsync(Platform::String^ fileName);

        //reads the contents of the file but returns only a progress
        Windows::Foundation::IAsyncActionWithProgress<double>^
            ReadTxtFileWithProgressAsync(Platform::String^ fileName);

        //reads the contents of the file and returns the number of bytes read. 
        //Does not return progress
        Windows::Foundation::IAsyncOperation<int>^ GetByteCountAsync(Platform::String^ fileName);

        //reads the contents of the file and returns the number of bytes read.
        //also provides progress information
        Windows::Foundation::IAsyncOperationWithProgress<int, double>^ 
            GetByteCountWithProgressAsync(Platform::String^ fileName);

    private:
        int m_bytesRead;
    };
}