﻿//
// MainPage.xaml.cpp
// Implementation of the MainPage class.
//

#include "pch.h"
#include "MainPage.xaml.h"
#include <ppltasks.h>
using namespace Concurrency;

using namespace TasksFileReadApp;

using namespace Platform;
using namespace Windows::Foundation;
using namespace Windows::Foundation::Collections;
using namespace Windows::UI::Xaml;
using namespace Windows::UI::Xaml::Controls;
using namespace Windows::UI::Xaml::Controls::Primitives;
using namespace Windows::UI::Xaml::Data;
using namespace Windows::UI::Xaml::Input;
using namespace Windows::UI::Xaml::Media;
using namespace Windows::UI::Xaml::Navigation;
using namespace Windows::Storage::Pickers;
using namespace Windows::Storage;
using namespace Platform::Collections;
using namespace Windows::Storage::Streams;

// The Blank Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=234238

MainPage::MainPage()
{
    InitializeComponent();
}

/// <summary>
/// Invoked when this page is about to be displayed in a Frame.
/// </summary>
/// <param name="e">Event data that describes how this page was reached.  The Parameter
/// property is typically used to configure the page.</param>
void MainPage::OnNavigatedTo(NavigationEventArgs^ e)
{
    (void) e;	// Unused parameter
}


void TasksFileReadApp::MainPage::ReadBtn_Click_1(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e)
{	

    auto picker = ref new FileOpenPicker();
    picker->FileTypeFilter->Append(".txt");
    picker->SuggestedStartLocation = PickerLocationId::DocumentsLibrary;

    create_task(picker->PickSingleFileAsync()).then([this](StorageFile^ file)
    {
        if (file)
        {
            task<IRandomAccessStream^> openTask(file->OpenAsync(FileAccessMode::Read));
            openTask.then([this](IRandomAccessStream^ stream)
            {
                auto reader = ref new DataReader(stream);
                task<UINT> loadTask(reader->LoadAsync(static_cast<UINT>(stream->Size)));
                loadTask.then([this, reader](UINT bytesRead)
                {
                    this->FileContent->Text = reader->ReadString(bytesRead);
                });
            });

        }
    });

}
