﻿//
// MainPage.xaml.h
// Declaration of the MainPage class.
//

#pragma once

#include "MainPage.g.h"
#include "Common\LayoutAwarePage.h"

namespace BasicControls
{
	[Windows::UI::Xaml::Data::Bindable]
	public ref class Scenario sealed
	{
	public:
		Scenario() {}
	public:
		Platform::String^ ToString()
		{
			return Title->ToString();
		}

	public:
		property Platform::String^ Title
		{
			Platform::String^ get()
			{
				return _title;
			}
			void set(Platform::String^ title)
			{
				_title = title;
			}
		}

		property Windows::UI::Xaml::Interop::TypeName ClassType
		{
			Windows::UI::Xaml::Interop::TypeName get()
			{
				return _classType;
			}
			void set(Windows::UI::Xaml::Interop::TypeName classType)
			{
				_classType = classType;
			}
		}
	private:
		Platform::String^ _title;
		Windows::UI::Xaml::Interop::TypeName _classType;

	};

	
	/// <summary>
	/// An empty page that can be used on its own or navigated to within a Frame.
	/// </summary>
	public ref class MainPage sealed 
	{
	public:
		MainPage();	 			
		void LoadScenario(Windows::UI::Xaml::Interop::TypeName classType);

	private:
		Platform::String^ FEATURE_NAME;
		std::vector<BasicControls::Scenario^> _scenario;
		static MainPage^ _current;
		Windows::UI::Xaml::Controls::Frame^	_hiddenFrame;

	public:		
		static property MainPage^ Current
		{
			MainPage^ get()
			{
				return _current;
			}
		}
		property Platform::String^ Feature
		{
			Platform::String^ get()
			{
				return FEATURE_NAME;
			}
		}

		
	protected:
		virtual void OnNavigatedTo(Windows::UI::Xaml::Navigation::NavigationEventArgs^ e) override ;
		void Scenarios_SelectionChanged(Platform::Object^ sender, Windows::UI::Xaml::Controls::SelectionChangedEventArgs^ args);

	private:
		void BuildScenarios();
		void PopulateScenarios();
		void InvalidateViewState();
	};
}

