﻿//
// MainPage.xaml.cpp
// Implementation of the MainPage class.
//

#include "pch.h"
#include "MainPage.xaml.h"

using namespace CanvasApp;

using namespace Platform;
using namespace Windows::Foundation;
using namespace Windows::Foundation::Collections;
using namespace Windows::UI::Xaml;
using namespace Windows::UI::Xaml::Controls;
using namespace Windows::UI::Xaml::Controls::Primitives;
using namespace Windows::UI::Xaml::Data;
using namespace Windows::UI::Xaml::Input;
using namespace Windows::UI::Xaml::Media;
using namespace Windows::UI::Xaml::Navigation;

// The Blank Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=234238

MainPage::MainPage()
{
	InitializeComponent();
	GenerateUI();
}

/// <summary>
/// Invoked when this page is about to be displayed in a Frame.
/// </summary>
/// <param name="e">Event data that describes how this page was reached.  The Parameter
/// property is typically used to configure the page.</param>
void MainPage::OnNavigatedTo(NavigationEventArgs^ e)
{
	(void) e;	// Unused parameter
}


// Function to generate XAML Canvas based UI through code
void MainPage::GenerateUI()
{
	// setup the base canvas first.

	auto myCanvas = ref new Windows::UI::Xaml::Controls::Canvas();
	auto canvasBrush = ref new SolidColorBrush();
	canvasBrush->Color = Windows::UI::Colors::Black;
	myCanvas->Background = canvasBrush;

	// Create the rectangle
	auto rectangle = ref new Windows::UI::Xaml::Shapes::Rectangle();
	// set rectangle Fill to Green
	auto rectBrush = ref new SolidColorBrush();
	rectBrush->Color = Windows::UI::Colors::White;	
	rectangle->Fill = rectBrush;

	auto rectStroke = ref new SolidColorBrush();
	rectStroke->Color = Windows::UI::Colors::White;
	rectangle->Stroke = rectStroke;
	rectangle->StrokeThickness = 3.5;
	// Set other properties for the Rectangle
	rectangle->Height = 435.82;
	rectangle->Width = 416.418;
	// Set rectangle position relative to Canvas
	myCanvas->SetLeft(rectangle, 84.419);
	myCanvas->SetTop(rectangle, 59.703);

	// now let us setup the TextBlock
	auto textBlock = ref new TextBlock();
	textBlock->Text = "Hello Panels";

	auto textBrush = ref new SolidColorBrush();
	textBrush->Color = Windows::UI::Colors::Black;
	textBlock->Foreground = textBrush;
	textBlock->Height = 41.403;
	textBlock->Width = 294.03;
	textBlock->TextWrapping = Windows::UI::Xaml::TextWrapping::Wrap;
	auto font = ref new Windows::UI::Xaml::Media::FontFamily("Arial");
	textBlock->FontFamily = font;
	textBlock->FontStyle = Windows::UI::Text::FontStyle::Normal;
	textBlock->FontSize = 25;
	textBlock->FontWeight = Windows::UI::Text::FontWeights::Bold;	
	myCanvas->SetLeft(textBlock, 158.224);
	myCanvas->SetTop(textBlock, 86.761);

	//Now let us create an ellipse
	auto ellipse = ref new Windows::UI::Xaml::Shapes::Ellipse();
	auto ellipseBrush = ref new SolidColorBrush();
	ellipseBrush->Color = Windows::UI::Colors::White;
	ellipse->Fill = ellipseBrush;
	ellipse->Height = 262.761;
	ellipse->Width = 239.97;
	myCanvas->SetLeft(ellipse, 158.224);
	myCanvas->SetTop(ellipse, 147.864);
	auto ellipseStroke = ref new SolidColorBrush();
	ellipseStroke->Color = Windows::UI::Colors::Black;
	ellipse->Stroke = ellipseStroke;
	ellipse->StrokeThickness = 5.0;

	// Add the elements to the Canvas
	myCanvas->Children->Append(rectangle);
	myCanvas->Children->Append(textBlock);
	myCanvas->Children->Append(ellipse);
	this->Content = myCanvas;

}