﻿//
// MainPage.xaml.cpp
// Implementation of the MainPage class.
//

#include "pch.h"
#include "MainPage.xaml.h"

using namespace DataBindingApp;

using namespace Platform;
using namespace Windows::Foundation;
using namespace Windows::Foundation::Collections;
using namespace Windows::UI::Xaml;
using namespace Windows::UI::Xaml::Controls;
using namespace Windows::UI::Xaml::Controls::Primitives;
using namespace Windows::UI::Xaml::Data;
using namespace Windows::UI::Xaml::Input;
using namespace Windows::UI::Xaml::Media;
using namespace Windows::UI::Xaml::Navigation;

// The Blank Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=234238

MainPage::MainPage()
{
	InitializeComponent();
	this->Loaded += ref new Windows::UI::Xaml::RoutedEventHandler(this, &MainPage::OnLoaded);
}

/// <summary>
/// Invoked when this page is about to be displayed in a Frame.
/// </summary>
/// <param name="e">Event data that describes how this page was reached.  The Parameter
/// property is typically used to configure the page.</param>
void MainPage::OnNavigatedTo(NavigationEventArgs^ e)
{
	(void) e;	// Unused parameter
}


void MainPage::OnLoaded(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e)
{
	App::Current->UnhandledException += ref new UnhandledExceptionEventHandler(this, &MainPage::UnhandledError);
	//Always use standard C++ types
	const std::wstring fName = L"John";
	const std::wstring lName = L"Doe";
	const std::wstring email = L"John.Doe@somewhere.com";

	Person^ p1 = ref new Person();
	//Use Platform and other WinRT types only when interfacing with WinRT 
	p1->FirstName = ref new String(fName.c_str());
	p1->LastName = ref new String(lName.c_str());
	p1->EmailAddress = ref new String(email.c_str());

	m_contacts = ref new Vector<Person^>;
	m_contacts->Append(p1);

	ContactListing->ItemsSource = m_contacts;
	
}

void MainPage::UnhandledError(Platform::Object^ sender, Windows::UI::Xaml::UnhandledExceptionEventArgs^ e)
{
	String^ error = e->Message;
}