#include "pch.h"

namespace DataBindingApp
{
	[BindableAttribute]
	public ref class Person sealed
	{
	public:
		Person();
		virtual ~Person();

	private:
		String^ m_firstName;
		String^ m_lastName;
		String^ m_emailAddress;
		String^ m_fullName;

	public:
		property String^ FirstName
		{
			String^ get() 
			{
				return m_firstName;
			}

			void set(String^ value)
			{
				if (value->IsEmpty())
				{
					throw ref new Platform::InvalidArgumentException();
				}
				m_firstName = value;
			}
		}

		property String^ LastName
		{
			String^ get() 
			{
				return m_lastName;
			}

			void set(String^ value)
			{
				if (value->IsEmpty())
				{
					throw ref new Platform::InvalidArgumentException();
				}
				m_lastName = value;
			}
		}

		property String^ EmailAddress
		{
			String^ get() 
			{
				return m_emailAddress;
			}

			void set(String^ value)
			{
				if (value->IsEmpty())
				{
					throw ref new Platform::InvalidArgumentException();
				}
				m_emailAddress = value;
			}
		}

		property String^ FullName
		{
			String^ get()
			{
				m_fullName = m_firstName + " " + m_lastName;
				return m_fullName;
			}
		}
	};
}