﻿//
// MainPage.xaml.cpp
// Implementation of the MainPage class.
//

#include "pch.h"
#include "MainPage.xaml.h"

using namespace StackPanelApp;

using namespace Platform;
using namespace Windows::Foundation;
using namespace Windows::Foundation::Collections;
using namespace Windows::UI::Xaml;
using namespace Windows::UI::Xaml::Controls;
using namespace Windows::UI::Xaml::Controls::Primitives;
using namespace Windows::UI::Xaml::Data;
using namespace Windows::UI::Xaml::Input;
using namespace Windows::UI::Xaml::Media;
using namespace Windows::UI::Xaml::Navigation;

// The Blank Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=234238

MainPage::MainPage()
{
	InitializeComponent();
	GenerateUI();
}

/// <summary>
/// Invoked when this page is about to be displayed in a Frame.
/// </summary>
/// <param name="e">Event data that describes how this page was reached.  The Parameter
/// property is typically used to configure the page.</param>
void MainPage::OnNavigatedTo(NavigationEventArgs^ e)
{
	(void) e;	// Unused parameter
}

// Helper function to generate XAML UI through code
void MainPage::GenerateUI()
{
	// create the StackPanel first
	auto stackpanel = ref new StackPanel();
	stackpanel->Orientation = Windows::UI::Xaml::Controls::Orientation::Horizontal;
	//create and set the margin 
	Windows::UI::Xaml::Thickness margin(5);
	stackpanel->Margin = margin;

	// Create the rectangle
	auto rectangle = ref new Windows::UI::Xaml::Shapes::Rectangle();
	// set rectangle Fill to White
	auto rectBrush = ref new SolidColorBrush();
	rectBrush->Color = Windows::UI::Colors::White;	
	rectangle->Fill = rectBrush;
	
	// Set other properties for the Rectangle
	rectangle->Height = 435.82;
	rectangle->Width = 416.418;
	
	// now let us setup the TextBlock
	auto textBlock = ref new TextBlock();
	textBlock->Text = "Hello Panels";

	auto textBrush = ref new SolidColorBrush();
	textBrush->Color = Windows::UI::Colors::White;
	textBlock->Foreground = textBrush;
	textBlock->Height = 41.403;
	textBlock->Width = 294.03;
	textBlock->TextWrapping = Windows::UI::Xaml::TextWrapping::Wrap;
	auto font = ref new Windows::UI::Xaml::Media::FontFamily("Arial");
	textBlock->FontFamily = font;
	textBlock->FontStyle = Windows::UI::Text::FontStyle::Normal;
	textBlock->FontSize = 25;
	textBlock->FontWeight = Windows::UI::Text::FontWeights::Bold;	
	
	//Now let us create an ellipse
	auto ellipse = ref new Windows::UI::Xaml::Shapes::Ellipse();
	auto ellipseBrush = ref new SolidColorBrush();
	ellipseBrush->Color = Windows::UI::Colors::White;
	ellipse->Fill = ellipseBrush;
	ellipse->Height = 262.761;
	ellipse->Width = 239.97;
	ellipse->Margin = margin;	
	// Add the elements to the Canvas
	stackpanel->Children->Append(rectangle);
	stackpanel->Children->Append(textBlock);
	stackpanel->Children->Append(ellipse);

	this->Content = stackpanel;
}