﻿//
// MainPage.xaml.h
// Declaration of the MainPage class.
//

#pragma once

#include "MainPage.g.h"
#include "ShapeRenderer.h"

namespace DrawIt
{
	/// <summary>
	/// An empty page that can be used on its own or navigated to within a Frame.
	/// </summary>
	public ref class MainPage sealed
	{
	public:
		MainPage();

		private:
        void OnLogicalDpiChanged(
            Platform::Object^ sender
            );
        
		void OnWindowSizeChanged(
            Windows::UI::Core::CoreWindow^ sender,
            Windows::UI::Core::WindowSizeChangedEventArgs^ args
            );
        
        void OnPointerPressed(
            Platform::Object^ sender,
            Windows::UI::Xaml::Input::PointerRoutedEventArgs^ args);
            
        void OnPointerReleased(
            Platform::Object^ sender,
            Windows::UI::Xaml::Input::PointerRoutedEventArgs^ args);
            
        void OnPointerMoved(
            Platform::Object^ sender,
            Windows::UI::Xaml::Input::PointerRoutedEventArgs^ args);
            

        void AddColorsClicked(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
        void RedColorClicked();
        void GreenColorClicked();
        void SaveClicked(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
        void ShareClicked(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);        

		void AddSizeChangeClicked(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
		void SixPointButtonClicked();
		void EightPointButtonClicked();
		void TenPointButtonClicked();

        ShapeRenderer^						m_renderer;
        bool								m_atStartScreen;		
	};

}

