#pragma once

#include "pch.h"
#include "DirectXHelpers.h"

namespace SiSSample
{
	class XamlSiS
	{
	public:
		XamlSiS(SurfaceImageSource^ surfaceImageSource, int width, int height);
		~XamlSiS();

		void DrawD2DImage(String^ fileName);
	
	protected:
		void CreateDeviceIndependentResources(SurfaceImageSource^ surfaceImageSource);
		void CreateDeviceResources();
	
	private:
	Microsoft::WRL::ComPtr<ISurfaceImageSourceNative>	m_sisNative;
	Microsoft::WRL::ComPtr<ID3D11Device>		        m_d3dDevice;
	Microsoft::WRL::ComPtr<ID3D11DeviceContext>			m_d3dContext;	
	Microsoft::WRL::ComPtr<ID2D1DeviceContext>			m_d2dContext;
	Microsoft::WRL::ComPtr<ID2D1LinearGradientBrush>	m_d2dBrush;
	Microsoft::WRL::ComPtr<IWICImagingFactory>			m_pIWICFactory;
	Microsoft::WRL::ComPtr<ID2D1Bitmap>					m_pD2DBitmap;
	Microsoft::WRL::ComPtr<IWICFormatConverter>			m_pConvertedSourceBitmap;
		
	int													_width;
	int													_height;	
	};
}