﻿//
// App.xaml.cpp
// Implementation of the App class.
//

#include "pch.h"


using namespace SimpleTriangle;

using namespace Platform;
using namespace Windows::ApplicationModel;
using namespace Windows::ApplicationModel::Activation;
using namespace Windows::Foundation;
using namespace Windows::Foundation::Collections;
using namespace Windows::UI::Xaml;
using namespace Windows::UI::Xaml::Controls;
using namespace Windows::UI::Xaml::Controls::Primitives;
using namespace Windows::UI::Core;
using namespace Windows::UI::Xaml::Data;
using namespace Windows::UI::Xaml::Input;
using namespace Windows::UI::Xaml::Media;
using namespace Windows::UI::Xaml::Navigation;
using namespace Windows::Graphics::Display;

// The Blank Application template is documented at http://go.microsoft.com/fwlink/?LinkId=234227

/// <summary>
/// Initializes the singleton application object.  This is the first line of authored code
/// executed, and as such is the logical equivalent of main() or WinMain().
/// </summary>
App::App()
{
	InitializeComponent();
	Suspending += ref new SuspendingEventHandler(this, &App::OnSuspending);
}

App::~App()
{
}


/// <summary>
/// Invoked when the application is launched normally by the end user.  Other entry points
/// will be used when the application is launched to open a specific file, to display
/// search results, and so forth.
/// </summary>
/// <param name="args">Details about the launch request and process.</param>
void App::OnLaunched(Windows::ApplicationModel::Activation::LaunchActivatedEventArgs^ args)
{
	m_panel = ref new SwapChainBackgroundPanel();

	m_renderer = ref new TriangleRenderer(m_panel, Window::Current->CoreWindow->Bounds, DisplayProperties::LogicalDpi);

	Window::Current->CoreWindow->SizeChanged += ref new TypedEventHandler<CoreWindow^, WindowSizeChangedEventArgs^>(this, &App::WindowSizeChanged);

	Window::Current->Content = m_panel;
	m_eventToken = CompositionTarget::Rendering::add(ref new EventHandler<Object^>(this, &App::CompositionTargetRendering));

	Window::Current->Activate();
}

void App::CompositionTargetRendering(Platform::Object^ sender, Platform::Object^ args)
{
	// render loop
	m_renderer->Render();
	m_renderer->Present();
}

void App::WindowSizeChanged(CoreWindow^ sender, WindowSizeChangedEventArgs^ args)
{
	m_renderer->Resize(Window::Current->CoreWindow->Bounds);
}

void App::OnSuspending(Object^ sender, SuspendingEventArgs^ args)
{
    (void) sender; // Unused parameter.
    (void) args; // Unused parameter.
    
    delete m_eventToken;
}