#pragma once

#include "pch.h"

ref class DirectXPanelBase abstract
{

public:
	//DirectXPanelBase();
	//virtual ~DirectXPanelBase();
	
	virtual void Render() = 0;
    virtual void Present();
	virtual void Resize(Windows::Foundation::Rect newBounds);
	virtual void SetDpi(float dpi);
	
protected:
	virtual void Initialize(
		Windows::UI::Xaml::Controls::SwapChainBackgroundPanel^ panel, 
		Windows::Foundation::Rect bounds, 
		float dpi, bool enableD2D);

    virtual void CreateDeviceIndependentResources(Windows::UI::Xaml::Controls::SwapChainBackgroundPanel^ panel);
    virtual void CreateDeviceResources();
    virtual void CreateSizeDependentResources();
    virtual void OnSizeChanged();

internal:
	Windows::UI::Xaml::Controls::SwapChainBackgroundPanel^	m_panel;
	Microsoft::WRL::ComPtr<ISwapChainBackgroundPanelNative>	m_panelNative;	

	Microsoft::WRL::ComPtr<IDXGISwapChain1>				m_swapChain;	

	// D2D objects
    Microsoft::WRL::ComPtr<ID2D1Device>					m_d2dDevice;
    Microsoft::WRL::ComPtr<ID2D1DeviceContext>			m_d2dContext;
	Microsoft::WRL::ComPtr<ID2D1Bitmap1>				m_d2dTargetBitmap;

    // D3D objects
    Microsoft::WRL::ComPtr<ID3D11Device1>				m_d3dDevice;
    Microsoft::WRL::ComPtr<ID3D11DeviceContext1>		m_d3dContext;
    Microsoft::WRL::ComPtr<ID3D11RenderTargetView>		m_renderTargetView;
    Microsoft::WRL::ComPtr<ID3D11DepthStencilView>		m_depthStencilView;
	
	bool							m_d2dIsEnabled;
	Windows::Foundation::Size		m_renderTargetSize;
	D3D_FEATURE_LEVEL				m_featureLevel;
    Windows::Foundation::Rect		m_bounds;
	float                           m_dpi;
};

