#pragma once

#include "pch.h"

#include "DirectXPanelBase.h"
#include "BasicMath.h"
#include "DirectXHelpers.h"

ref class TriangleRenderer sealed : public DirectXPanelBase
{
public:
	TriangleRenderer(Windows::UI::Xaml::Controls::SwapChainBackgroundPanel^ panel, Windows::Foundation::Rect bounds, float dpi);	

	virtual void Render() override;

protected:
    virtual void CreateDeviceResources() override;

private:	
	~TriangleRenderer();

    Microsoft::WRL::ComPtr<ID3D11InputLayout>           m_inputLayout;
    Microsoft::WRL::ComPtr<ID3D11VertexShader>          m_vertexShader;
    Microsoft::WRL::ComPtr<ID3D11PixelShader>           m_pixelShader;

	Microsoft::WRL::ComPtr<ID3D11Buffer>				m_vertexBuffer;     
	Microsoft::WRL::ComPtr<ID3D11Buffer>				m_indexBuffer;

};