// AmpArray.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"

void main()
{
    //create an array of 5 integers
    std::vector<int> data(5);
    for (int i = 0; i < 5; ++i) 
    {
        data[i] = i;
    }

    //now create and initialize an AMP array with data from the array 'data' created above
    //specify the begin and end of the integer array
    concurrency::array<int, 1> ampData(5, std::begin(data), std::end(data));

    // we will multiply each element in the array by 10 and then copy data back from GPU to CPU.
    concurrency::parallel_for_each(ampData.extent, [&](concurrency::index<1> idx) restrict(amp)
    {
        ampData[idx] *= 10;
    });
    data = ampData;

    // accessing elements in the array
    for(const auto i: data)
        std::cout << i << std::endl;
}

