// AmpTexture.cpp : Defines the entry point for the console application.
//

#include <iostream>
#include <array>
#include <amp.h>
#include <amp_graphics.h>

void main()
{
    std::array<char, 11> v = { 'G', 'd', 'k', 'k', 'n', 31, 'V', 'n', 'q', 'k', 'c' };
	const concurrency::graphics::texture<int, 1> tex_in(UINT(v.size()), v.data(), UINT(v.size()), 8U);
	concurrency::graphics::texture<int, 1> tex_out(UINT(v.size()), 8U);
    concurrency::graphics::writeonly_texture_view<int, 1> tex_out_view(tex_out);

    concurrency::parallel_for_each(tex_in.extent, [=, &tex_in](concurrency::index<1> idx) restrict(amp)
    {
        tex_out_view.set(idx, tex_in[idx] + 1);
    });
	concurrency::graphics::copy(tex_out, v.data(), UINT(v.size()));

	for(auto i = 0U; i < UINT(v.size()); ++i)
        std::cout << v[i];   

    std::cout<<std::endl;
}
