#pragma once

#include "Direct3DBase.h"
#include "ComputeEngine.h"

struct VertexPositionColor
{
    DirectX::XMFLOAT3 pos;
    //DirectX::XMFLOAT3 color;
};

// This class renders a simple rotating triangle.
ref class TriangleRenderer sealed : public Direct3DBase
{
public:
    TriangleRenderer();

    // Direct3DBase methods.
    virtual void CreateDeviceResources() override;
    virtual void CreateWindowSizeDependentResources() override;
    virtual void Render() override;

    // Method for updating time-dependent objects.
    void Update(float timeTotal, float timeDelta);
    void ComputeRenderData();

private:
    bool m_loadingComplete;
    const unsigned int m_numVertices;

    Microsoft::WRL::ComPtr<ID3D11InputLayout> m_inputLayout;
    Microsoft::WRL::ComPtr<ID3D11Buffer> m_vertexBuffer;
    Microsoft::WRL::ComPtr<ID3D11Buffer> m_vertexPosBuffer;	
    Microsoft::WRL::ComPtr<ID3D11VertexShader> m_vertexShader;
    Microsoft::WRL::ComPtr<ID3D11PixelShader> m_pixelShader;	
    Microsoft::WRL::ComPtr<ID3D11ShaderResourceView> m_VertexPosBufferRV;

    std::unique_ptr<AMP_compute_engine> m_AmpComputeEngine;
};
