﻿//
// MainPage.xaml.h
// Declaration of the MainPage class.
//

#pragma once

#include "MainPage.g.h"
#include "PictureEffects.h"
#include "BasicTimer.h"

namespace ImageEffects
{
	/// <summary>
	/// An empty page that can be used on its own or navigated to within a Frame.
	/// </summary>
	public ref class MainPage sealed
	{
	public:
		MainPage();

		property Windows::Foundation::EventRegistrationToken RenderRegistrationToken
        {
            Windows::Foundation::EventRegistrationToken get()
            {
                return m_eventToken;
            }
        }

	private:
        void OnLogicalDpiChanged(
            Platform::Object^ sender
            );
        
		void OnWindowSizeChanged(
            Windows::UI::Core::CoreWindow^ sender,
            Windows::UI::Core::WindowSizeChangedEventArgs^ args
            );
            

        void ApplyEffectsClicked(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
        void SobelBtnClicked();
        void PrewitBtnClicked();
		void ScharBtnClicked();
		void EmbossBtnClicked();
		void GaussBtnClicked();
		void SharpenBtnClicked();
		void MeanRemBtnClicked();
        
		void OpenClicked(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);  


        PictureEffects^						m_effects;
		bool								m_renderNeeded;

		void OnRendering(Object^ sender, Object^ args);

		Windows::Foundation::EventRegistrationToken m_eventToken;
		BasicTimer^							m_timer;
	};

}

