#include "stdafx.h"
#include "CppUnitTest.h"
#include "..\RootFinder\RootFinder.h"
#include <stdexcept>
#include <string>
using namespace std;

using namespace Microsoft::VisualStudio::CppUnitTestFramework;

namespace NativeRooterTest
{		
	TEST_CLASS(UnitTest1)
	{
	public:
		
		TEST_METHOD(TestMethod1)
		{
			// TODO: Your test code here
			CRootFinder finder;
			Assert::AreEqual(0.0, finder.SquareRoot(0.0), 0.01, L"custom message", LINE_INFO());
		}

		TEST_METHOD(RangeChecker)
		{
			CRootFinder finder;
			for (double v = 1e-6; v < 1e6; v *= 3.2)
			{
				double value = finder.SquareRoot(v*v);
				Assert::AreEqual(v, value, v/1000);
			}
		}

		TEST_METHOD(NegativeRangeChecker)
		{
			CRootFinder finder;
			wstring wstrMsg;

			for (double v = -0.1; v > -3.0; v -= 0.5)
			{
				try
				{
					double value = finder.SquareRoot(v);
					wstrMsg = L"No exception for input";
					Assert::Fail(wstrMsg.c_str(), LINE_INFO());
				}
				catch(std::out_of_range ex)
				{
					continue;
				}
				catch(...)
				{
					wstrMsg = L"Incorrect exception for input value";
					Assert::Fail(wstrMsg.c_str(), LINE_INFO());
				}
			}

		}

	};
}